type 'a t = 'a cell Lazy.t
and 'a cell = Cons of ('a * 'a t)
;;

let fc = Lazy.force;;

let rec filter p xs = match fc xs with
 | Cons (x, xs) ->
  if p x then lazy (Cons (x, filter p xs)) else filter p xs
;;

let hd xs = match fc xs with Cons (x, _) -> x;;

let rec map f xs = match fc xs with
 | Cons (x, xs) -> lazy (Cons (f x, map f xs))
;;

let rec take n xs = match (n, fc xs) with
 | (0, _) -> []
 | (n, Cons (x, xs)) -> x :: take (n - 1) xs
;;

let tl xs = match fc xs with Cons (_, xs) -> xs;;

let rec unzip xs = (map fst xs, map snd xs);;

let rec zip xs ys = match (fc xs, fc ys) with
 | (Cons (x, xs), Cons (y, ys)) -> lazy (Cons ((x, y), zip xs ys))
;;
